searchNodes=[{"doc":"FileStore allows you to read, write, upload, download, and interact with files, regardless of where they are stored. Adapters This package ships with the following adapters: FileStore.Adapters.Disk FileStore.Adapters.S3 FileStore.Adapters.Memory FileStore.Adapters.Null The documentation for each adapter includes an example that demonstrates it's usage.","ref":"FileStore.html","title":"FileStore","type":"protocol"},{"doc":"Copy a file to a new location. Examples iex&gt; FileStore . copy ( store , &quot;path/foo.txt&quot; , &quot;path/bar.txt&quot; ) :ok","ref":"FileStore.html#copy/3","title":"FileStore.copy/3","type":"function"},{"doc":"Delete a file from the store. Examples iex&gt; FileStore.delete(store, &quot;foo&quot;) :ok","ref":"FileStore.html#delete/2","title":"FileStore.delete/2","type":"function"},{"doc":"Delete files in bulk. Options :prefix - Only delete keys matching the given prefix. Examples iex&gt; FileStore.delete_all(store) :ok iex&gt; FileStore.delete_all(store, prefix: &quot;foo/&quot;) :ok","ref":"FileStore.html#delete_all/2","title":"FileStore.delete_all/2","type":"function"},{"doc":"Download a file from the store and save it to the given path . Examples iex&gt; FileStore . download ( store , &quot;foo&quot; , &quot;/path/to/bar.txt&quot; ) :ok","ref":"FileStore.html#download/3","title":"FileStore.download/3","type":"function"},{"doc":"Get URL for your file, assuming that the file is publicly accessible. Options :content_type - Force the Content-Type of the response. :disposition - Force the Content-Disposition of the response. Examples iex&gt; FileStore . get_public_url ( store , &quot;foo&quot; ) &quot;https://mybucket.s3-us-east-1.amazonaws.com/foo&quot;","ref":"FileStore.html#get_public_url/3","title":"FileStore.get_public_url/3","type":"function"},{"doc":"Generate a signed URL for your file. Any user with this URL should be able to access the file. Options :expires_in - The number of seconds before the URL expires. :content_type - Force the Content-Type of the response. :disposition - Force the Content-Disposition of the response. Examples iex&gt; FileStore . get_signed_url ( store , &quot;foo&quot; ) { :ok , &quot;https://s3.amazonaws.com/mybucket/foo?X-AMZ-Expires=3600&amp;...&quot; }","ref":"FileStore.html#get_signed_url/3","title":"FileStore.get_signed_url/3","type":"function"},{"doc":"List files in the store. Options :prefix - Only return keys matching the given prefix. Examples iex&gt; Enum . to_list ( FileStore . list! ( store ) ) [ &quot;bar&quot; , &quot;foo/bar&quot; ] iex&gt; Enum . to_list ( FileStore . list! ( store , prefix : &quot;foo&quot; ) ) [ &quot;foo/bar&quot; ]","ref":"FileStore.html#list!/2","title":"FileStore.list!/2","type":"function"},{"doc":"Read the contents of a file in store into memory. Examples iex&gt; FileStore . read ( store , &quot;foo&quot; ) { :ok , &quot;hello world&quot; }","ref":"FileStore.html#read/2","title":"FileStore.read/2","type":"function"},{"doc":"Renames a file from one name to another. Note : Some underlying adapters can not do this in an atomic fashion. Examples iex&gt; FileStore . rename ( store , &quot;path/foo.txt&quot; , &quot;path/bar.txt&quot; ) :ok","ref":"FileStore.html#rename/3","title":"FileStore.rename/3","type":"function"},{"doc":"Retrieve information about a file from the store. Examples iex&gt; FileStore . stat ( store , &quot;foo&quot; ) { :ok , % FileStore.Stat { key : &quot;foo&quot; , etag : &quot;2e5pd429&quot; , size : 24 } }","ref":"FileStore.html#stat/2","title":"FileStore.stat/2","type":"function"},{"doc":"Upload a file to the store. If a file with the given key already exists, it will be overwritten. Examples iex&gt; FileStore . upload ( store , &quot;/path/to/bar.txt&quot; , &quot;foo&quot; ) :ok","ref":"FileStore.html#upload/3","title":"FileStore.upload/3","type":"function"},{"doc":"Write a file to the store. If a file with the given key already exists, it will be overwritten. Options * ` :content_type ` - Sets the content type hint for the adapter . * ` :disposition ` - Sets the content disposition hint for the adapter . Examples iex&gt; FileStore . write ( store , &quot;foo&quot; , &quot;hello world&quot; ) :ok","ref":"FileStore.html#write/4","title":"FileStore.write/4","type":"function"},{"doc":"","ref":"FileStore.html#t:delete_all_opts/0","title":"FileStore.delete_all_opts/0","type":"type"},{"doc":"","ref":"FileStore.html#t:key/0","title":"FileStore.key/0","type":"type"},{"doc":"","ref":"FileStore.html#t:list_opts/0","title":"FileStore.list_opts/0","type":"type"},{"doc":"","ref":"FileStore.html#t:public_url_opts/0","title":"FileStore.public_url_opts/0","type":"type"},{"doc":"","ref":"FileStore.html#t:signed_url_opts/0","title":"FileStore.signed_url_opts/0","type":"type"},{"doc":"","ref":"FileStore.html#t:t/0","title":"FileStore.t/0","type":"type"},{"doc":"","ref":"FileStore.html#t:write_opts/0","title":"FileStore.write_opts/0","type":"type"},{"doc":"Stores files on the local disk. This is primarily intended for development. Configuration storage_path - The path on disk where files are stored. This option is required. base_url - The base URL that should be used for generating URLs to your files. Example iex&gt; store = FileStore.Adapters.Disk . new ( ...&gt; storage_path : &quot;/path/to/store/files&quot; , ...&gt; base_url : &quot;http://example.com/files/&quot; ...&gt; ) % FileStore.Adapters.Disk { ... } iex&gt; FileStore . write ( store , &quot;foo&quot; , &quot;hello world&quot; ) :ok iex&gt; FileStore . read ( store , &quot;foo&quot; ) { :ok , &quot;hello world&quot; }","ref":"FileStore.Adapters.Disk.html","title":"FileStore.Adapters.Disk","type":"module"},{"doc":"Get an the path for a given key.","ref":"FileStore.Adapters.Disk.html#join/2","title":"FileStore.Adapters.Disk.join/2","type":"function"},{"doc":"Create a new disk adapter","ref":"FileStore.Adapters.Disk.html#new/1","title":"FileStore.Adapters.Disk.new/1","type":"function"},{"doc":"Stores files in memory. This adapter is particularly useful in tests. Configuration name - The name used to register the process. base_url - The base URL that should be used for generating URLs to your files. Example iex&gt; store = FileStore.Adapters.Memory . new ( base_url : &quot;http://example.com/files/&quot; ) % FileStore.Adapters.Memory { ... } iex&gt; FileStore . write ( store , &quot;foo&quot; , &quot;hello world&quot; ) :ok iex&gt; FileStore . read ( store , &quot;foo&quot; ) { :ok , &quot;hello world&quot; } Usage in tests defmodule MyTest do use ExUnit.Case setup do start_supervised! ( FileStore.Adapters.Memory ) :ok end test &quot;writes a file&quot; do store = FileStore.Adapters.Memory . new ( ) assert :ok = FileStore . write ( store , &quot;foo&quot; , &quot;bar&quot; ) assert { :ok , &quot;bar&quot; } = FileStore . read ( store , &quot;foo&quot; ) end end","ref":"FileStore.Adapters.Memory.html","title":"FileStore.Adapters.Memory","type":"module"},{"doc":"Returns a specification to start this module under a supervisor. See Supervisor .","ref":"FileStore.Adapters.Memory.html#child_spec/1","title":"FileStore.Adapters.Memory.child_spec/1","type":"function"},{"doc":"Creates a new memory adapter","ref":"FileStore.Adapters.Memory.html#new/1","title":"FileStore.Adapters.Memory.new/1","type":"function"},{"doc":"Starts an agent for the test adapter.","ref":"FileStore.Adapters.Memory.html#start_link/1","title":"FileStore.Adapters.Memory.start_link/1","type":"function"},{"doc":"Stops the agent for the test adapter.","ref":"FileStore.Adapters.Memory.html#stop/3","title":"FileStore.Adapters.Memory.stop/3","type":"function"},{"doc":"Does not attempt to store files. Example iex&gt; store = FileStore.Adapters.Null . new ( ) % FileStore.Adapters.Null { ... } iex&gt; FileStore . write ( store , &quot;foo&quot; , &quot;hello world&quot; ) :ok iex&gt; FileStore . read ( store , &quot;foo&quot; ) { :ok , &quot;hello world&quot; }","ref":"FileStore.Adapters.Null.html","title":"FileStore.Adapters.Null","type":"module"},{"doc":"Creates a new null adapter","ref":"FileStore.Adapters.Null.html#new/1","title":"FileStore.Adapters.Null.new/1","type":"function"},{"doc":"Stores files using Amazon S3. Dependencies To use this adapter, you'll need to install and configure ExAws.S3 . Configuration bucket - The name of your S3 bucket. This option is required. ex_aws - A keyword list of options that can be used to override the default configuration for ExAws . Example iex&gt; store = FileStore.Adapters.S3 . new ( ...&gt; bucket : &quot;mybucket&quot; ...&gt; ) % FileStore.Adapters.S3 { ... } iex&gt; FileStore . write ( store , &quot;foo&quot; , &quot;hello world&quot; ) :ok iex&gt; FileStore . read ( store , &quot;foo&quot; ) { :ok , &quot;hello world&quot; }","ref":"FileStore.Adapters.S3.html","title":"FileStore.Adapters.S3","type":"module"},{"doc":"Create a new S3 adapter","ref":"FileStore.Adapters.S3.html#new/1","title":"FileStore.Adapters.S3.new/1","type":"function"},{"doc":"Define a configurable store. Usage First, define a new module: defmodule MyApp.Storage do use FileStore.Config , otp_app : :my_app end In your config files, you'll need to configure your adapter: config :my_app , MyApp.Storage , adapter : FileStore.Adapters.Disk , storage_path : &quot;/path/to/files&quot; , base_url : &quot;https://localhost:4000&quot; You can also configure any FileStore.Middleware here: config :my_app , MyApp.Storage , adapter : FileStore.Adapters.Disk , # ...etc... middleware : [ FileStore.Middleware.Errors ] If you need to dynamically configure your store at runtime, you can implement the init/1 callback. def init ( opts ) do Keyword . put ( opts , :foo , &quot;bar&quot; ) end Example iex&gt; MyApp.Storage . write ( &quot;foo&quot; , &quot;hello world&quot; ) :ok iex&gt; MyApp.Storage . read ( &quot;foo&quot; ) { :ok , &quot;hello world&quot; }","ref":"FileStore.Config.html","title":"FileStore.Config","type":"module"},{"doc":"Middleware allows you to enhance your store with additional functionality. The following middlewares ship with this library. FileStore.Middleware.Logger FileStore.Middleware.Errors FileStore.Middleware.Prefix To use a middleware, simply wrap your existing store with the middleware: iex&gt; store = FileStore.Adapters.Disk . new ( [ ... ] ) % FileStore.Adapters.Disk { ... } iex&gt; store = FileStore.Middleware.Logger . new ( store ) % FileStore.Middleware.Logger { ... } iex&gt; FileStore . read ( store , &quot;test.txt&quot; ) # 02:37:30.724 [debug] READ OK key=&quot;test.txt&quot; { :ok , &quot;hello&quot; } You can compose multiple middlewares, but order does matter. The following order is recommended: FileStore.Adapters.Null . new ( ) |&gt; FileStore.Middleware.Errors . new ( ) |&gt; FileStore.Middleware.Prefix . new ( prefix : &quot;foo&quot; ) |&gt; FileStore.Middleware.Logger . new ( )","ref":"FileStore.Middleware.html","title":"FileStore.Middleware","type":"module"},{"doc":"By default, each adapter will return errors in a different format. This middleware attempts to make the errors returned by this library a little more useful by wrapping them in exception structs: FileStore.Error FileStore.UploadError FileStore.DownloadError FileStore.CopyError FileStore.RenameError Each of these structs contain reason field, where you'll find the original error that was returned by the underlying adapter. One nice feature of this middleware is that it makes it easy to raise: store |&gt; FileStore.Middleware.Errors . new ( ) |&gt; FileStore . read ( &quot;example.jpg&quot; ) |&gt; case do { :ok , data } -&gt; data { :error , error } -&gt; raise error end See the documentation for FileStore.Middleware for more information.","ref":"FileStore.Middleware.Errors.html","title":"FileStore.Middleware.Errors","type":"module"},{"doc":"","ref":"FileStore.Middleware.Errors.html#new/1","title":"FileStore.Middleware.Errors.new/1","type":"function"},{"doc":"This middleware allows you to log all operations. See the documentation for FileStore.Middleware for more information.","ref":"FileStore.Middleware.Logger.html","title":"FileStore.Middleware.Logger","type":"module"},{"doc":"","ref":"FileStore.Middleware.Logger.html#new/1","title":"FileStore.Middleware.Logger.new/1","type":"function"},{"doc":"This module adds a prefix to all operations. store |&gt; FileStore.Middleware.Prefix . new ( prefix : &quot;companies/logos&quot; ) |&gt; FileStore . read ( &quot;example.jpg&quot; ) In the example above, the key example.jpg would become companies/logos/example.jpg . See the documentation for FileStore.Middleware for more information.","ref":"FileStore.Middleware.Prefix.html","title":"FileStore.Middleware.Prefix","type":"module"},{"doc":"Add the prefix adapter to your store.","ref":"FileStore.Middleware.Prefix.html#new/2","title":"FileStore.Middleware.Prefix.new/2","type":"function"},{"doc":"A struct that holds file information. Fields key - The unique identifier for the file. etag - A fingerprint for the contents of a file. This is almost always an MD5 checksum. size - The byte size of the file. type - The content-type of the file.","ref":"FileStore.Stat.html","title":"FileStore.Stat","type":"module"},{"doc":"Compute an MD5 checksum. Example iex&gt; FileStore.Stat . checksum ( &quot;hello world&quot; ) &quot;5eb63bbbe01eeed093cb22bb8f5acdc3&quot;","ref":"FileStore.Stat.html#checksum/1","title":"FileStore.Stat.checksum/1","type":"function"},{"doc":"Compute the MD5 checksum of a file on disk. Example iex&gt; FileStore.Stat . checksum_file ( &quot;test/fixtures/test.txt&quot; ) { :ok , &quot;0d599f0ec05c3bda8c3b8a68c32a1b47&quot; } iex&gt; FileStore.Stat . checksum_file ( &quot;test/fixtures/missing.txt&quot; ) { :error , :enoent }","ref":"FileStore.Stat.html#checksum_file/1","title":"FileStore.Stat.checksum_file/1","type":"function"},{"doc":"","ref":"FileStore.Stat.html#t:t/0","title":"FileStore.Stat.t/0","type":"type"},{"doc":"","ref":"FileStore.CopyError.html","title":"FileStore.CopyError","type":"exception"},{"doc":"","ref":"FileStore.DownloadError.html","title":"FileStore.DownloadError","type":"exception"},{"doc":"","ref":"FileStore.Error.html","title":"FileStore.Error","type":"exception"},{"doc":"","ref":"FileStore.RenameError.html","title":"FileStore.RenameError","type":"exception"},{"doc":"","ref":"FileStore.UploadError.html","title":"FileStore.UploadError","type":"exception"},{"doc":"FileStore allows you to read, write, upload, download, and interact with files, regardless of where they are stored. It includes adapters for the following storage backends: Disk S3 Memory Null View the documentation","ref":"readme.html","title":"FileStore","type":"extras"},{"doc":"The package can be installed by adding file_store to your list of dependencies in mix.exs : def deps do [ { :file_store , &quot;~&gt; 0.3&quot; } ] end","ref":"readme.html#installation","title":"FileStore - Installation","type":"extras"},{"doc":"Configure a new store: store = FileStore.Adapters.Disk . new ( storage_path : &quot;/path/to/store/files&quot; , base_url : &quot;http://example.com/files/&quot; ) Now, you can manipulate files in your store: iex&gt; FileStore . upload ( store , &quot;hello.txt&quot; , &quot;world.txt&quot; ) :ok iex&gt; FileStore . read ( store , &quot;world.txt&quot; ) { :ok , &quot;hello world&quot; } iex&gt; FileStore . stat ( store , &quot;world.txt&quot; ) { :ok , % FileStore.Stat { etag : &quot;5eb63bbbe01eeed093cb22bb8f5acdc3&quot; , key : &quot;hello.txt&quot; , size : 11 , type : &quot;application/octet-stream&quot; } } iex&gt; FileStore . get_public_url ( store , &quot;world.txt&quot; ) &quot;http://localhost:4000/world.txt&quot; Click here to see all available operations.","ref":"readme.html#usage","title":"FileStore - Usage","type":"extras"},{"doc":"Logger To enable logging, just wrap your store with the logging middleware: iex&gt; store ...&gt; |&gt; FileStore.Middleware.Logger . new ( ) ...&gt; |&gt; FileStore . read ( &quot;test.txt&quot; ) # 02:37:30.724 [debug] READ OK key=&quot;test.txt&quot; { :ok , &quot;hello&quot; } Errors The errors middleware will wrap error values: iex&gt; store ...&gt; |&gt; FileStore.Middleware.Errors . new ( ) ...&gt; |&gt; FileStore . read ( &quot;bizcorp.jpg&quot; ) { :error , % FileStore.Error { ... } } One of the following structs will be returned: FileStore.Error FileStore.UploadError FileStore.DownloadError FileStore.CopyError FileStore.RenameError Because the error implements the Exception behaviour, you can raise it. Prefix The prefix middleware allows you to prepend a prefix to all operations. iex&gt; store ...&gt; |&gt; FileStore.Middleware.Prefix . new ( prefix : &quot;company/logos&quot; ) ...&gt; |&gt; FileStore . read ( &quot;bizcorp.jpg&quot; ) In the example above, bizcorp.jpg was translated to companies/logos/bizcorp.jpg .","ref":"readme.html#middleware","title":"FileStore - Middleware","type":"extras"},{"doc":"You can also create a dedicated store in your application. defmodule MyApp.Storage do use FileStore.Config , otp_app : :my_app end You'll need to provide configuration for this module: config :my_app , MyApp.Storage , adapter : FileStore.Adapters.Null , middleware : [ FileStore.Middleware.Errors ] Now, you can interact with your store more conveniently: iex&gt; MyApp.Storage . write ( &quot;foo&quot; , &quot;hello world&quot; ) :ok iex&gt; MyApp.Storage . read ( &quot;foo&quot; ) { :ok , &quot;hello world&quot; }","ref":"readme.html#creating-a-store","title":"FileStore - Creating a store","type":"extras"},{"doc":"In order to test the S3 adapter, we run Minio locally in a Docker container. To start the Minio service, run the following script: $ bin/start To run the test suite, run: $ bin/test","ref":"readme.html#contributing","title":"FileStore - Contributing","type":"extras"}]